<template>
	<div class="drawing-details-wrapper">
		<div v-show="isLoading" class="spinner-wrapper"><spinner></spinner></div>
		<div v-show="!isLoading">
			<div class="drawing">
				<div class="drawing-created">Created on {{ drawingDetails.creationDate | moment("MMMM Do YYYY, H:mm") }} </div>
				<div class="drawing-took"> Took {{ drawingDetails.drawDuration | moment("mm:ss") }} Mins to draw</div>
				<canvas id="drawingDetailsCanvas" width="800" height="500"></canvas>
			</div>
			<div>
				<a id="downloadAsPngLink">
					<mdc-button :raised="true" :primary="true">Download as PNG</mdc-button>
				</a>
			</div>
		</div>
	</div>
</template>

<script>
import Spinner from 'vue-simple-spinner'
export default {
	components: {
		Spinner
	},
	data () {
		return {
			drawingDetails: {},
			isLoading: true
		}
	},
	mounted () {
		this.fetchDraw()
		this.setDownloadPngLink()
	},
	methods: {
		fetchDraw () {
			this.$http.get(`https://us-over-board-server.herokuapp.com/api/drawing/${this.$route.params.id}`)
				.then(function (response) {
					this.isLoading = false
					this.drawingDetails = response.body
					this.draw()
				})
				.catch(err => {
					this.isLoading = false
					console.log(err)
				})
		},

		draw () {
			const segments = this.drawingDetails.drawingSegments
			const canvas = this.$el.querySelector('#drawingDetailsCanvas')
			const ctx = canvas.getContext('2d')

			ctx.beginPath()
			ctx.strokeStyle = segments[0][0].brushColor
			ctx.lineWidth = segments[0][0].brushSize
			ctx.moveTo(segments[0][0].x, segments[0][0].y)
			this.drawStep(segments, ctx, 0, 0, 10)
		},
		
		drawStep (segments, ctx, sInd, pInd, pace) {
			if (!segments[sInd][pInd]) { 
				if (!segments[sInd + 1]) {	// Last point in the last segment
					return
				} else { // Last point in the current segment
					ctx.moveTo(segments[sInd + 1][0].x, segments[sInd + 1][0].y)
					ctx.closePath()
					ctx.beginPath()
					ctx.strokeStyle = segments[sInd + 1][0].brushColor
					ctx.lineWidth = segments[sInd + 1][0].brushSize
					setTimeout(this.drawStep, pace, segments, ctx, ++sInd, 0, pace)
				}
			} else {
				ctx.lineTo(segments[sInd][pInd].x, segments[sInd][pInd].y)
				ctx.stroke()
				setTimeout(this.drawStep, pace, segments, ctx, sInd, ++pInd, pace)
			}
		},

		setDownloadPngLink () {
			const el = this.$el.querySelector('#downloadAsPngLink')
			el.addEventListener('click', () => {
				el.href = this.drawingDetails.dataUrl
    			el.download = 'masterpiece.png'
			}, false)
		}
	}
}
</script>

<style scoped>
canvas {
	box-shadow: 10px 10px 41px 1px rgba(199,199,199,1);
	margin-bottom: 40px; 
}
.drawing-details-wrapper {
	text-align: center;
}

.drawing {
	display: inline-block;
	text-align: left;  
	line-height: 20px;
}

.drawing-took {
	color: #a6a6a6;
    font-size: 13px;
}
</style>
